#include <windows.h>
#include <stdio.h>
#include "init_D3D.h"
#include "decl_init_D3D.h"
#include "tutor.h"
#include "decl_vect_matr.h"
#include "mesh.h"
#include "decl_mesh.h"
#include "decl_timer.h"
#include "decl_cam_mde.h"
#include "decl_effets.h"
#include "init_DS.h"
#include "decl_init_DS.h"
#include "decl_sons.h"
#include "vertices.h"
#include "decl_vertices.h"

VOID Cleanup();
VOID SetupMatrices();

  float pl[30][3] =
{
{-90, 100, 100}, {0, 200, 0}, {-100, 100, -90}, {-100, 200, -200}, {-200, -100, -250}, {-190, -100, 190}, {0, 190, 190},
{190, 200, -100}, {-250, -240, -100}, {-80, 100, -90}, {100, 110, 100}, {-90, -80, 100}, {0, 200, 200}, {-200, -100, 200}, {-240, 190, -190},
{-100, -200, 200}, {200, 0, 200}, {100, -100, 110}, {190, 0, 10}, {100, -90, -80}, {200, 190, -100}, {190, -100, -190}, {-100, -190, -240},
{200, -250, -200}, {110, -90, -100}, {-190, -200, -100}, {200, 190, 0}, {10, 0, 0}, {190, 10, 190}, {-100, -190, 190},
};

_mesh_ *mtm[10];

LONGLONG *temps;

clavier et_module = {0, 0, 0, 0};
clavier et_module2 = {0, 0, 0, 0};

D3DMATRIX *mat_proj;

VOID Cleanup()
{

	if( obj_Direct3DDevice != NULL)
		obj_Direct3DDevice->Release();

	if( obj_Direct3D != NULL)
		obj_Direct3D->Release();

	if( obj_Direct3DDevice2 != NULL)
		obj_Direct3DDevice2->Release();

	if( obj_Direct3D2 != NULL)
		obj_Direct3D2->Release();

	unsigned int i;

	for (i = 0; i<NBR_SNDS; i++) 
		if( DSbuffer[i] != NULL)
			DSbuffer[i]->Release();

	if( obj_DirectSound != NULL)
		obj_DirectSound->Release();


	for (i = 0; i<10; i++) {
		if (mtm[i]->Materiaux)
		delete[] mtm[i]->Materiaux;

		if (mtm[i]->Textures) {
			for(unsigned int j=0; j<mtm[i]->nbr_de_mat; j++)
				if (mtm[i]->Textures[j])
					mtm[i]->Textures[j]->Release();
				delete[] mtm[i]->Textures;
		}

	if(mtm[i]->obj_mesh)
		mtm[i]->obj_mesh->Release();
	}

}

	int fin = 0;

	void test_cell(Missile *r, Missile *c) {

		int l = 0;
		if((*c)->precedent){
			(*c)->precedent->suivant = (*c)->suivant;
			if((*c)->suivant)
				(*c)->suivant->precedent = (*c)->precedent;
			return;
		}
		else {
			(*r) = (*c)->suivant;
			if((*r))
				(*r)->precedent = NULL;
			return;
		}
	}

	float _A_, _fi_;

void fini(HWND hWnd) {

	RECT rect;
	rect.bottom = 160;
	rect.left = 20;
	rect.right = 260;
	rect.top = 40;

	HDC hdc;
    hdc = GetDC( hWnd );

	SetBkColor(hdc, 0x000000);
	SetTextColor(hdc, 0xff0000);
	DrawText(hdc, "GAME OVER", 9, &rect, DT_CENTER);

}

void eloignement(LPDIRECT3DDEVICE9 *D3DD, _module_ *rp) {

	rp->position_cam.z+=rp->coef_cam;

	D3DVECTOR b = {0.0f, -.707f, .707f};
	vue(rp, b, &(*D3DD));

	rp->position_cam.z-=rp->coef_cam;
}

void affich_vies(LPDIRECT3DDEVICE9 *D3DD, _mesh_ *mtm_coeur, float alpha, _module_ *rp) {

	rp->monde._42 = -5.0f;
	rp->monde._43 = 20.0f;
	rp->monde._11 = rp->monde._33 = 1.0f;
	rp->monde._13 = rp->monde._31 = 0.0f;

	for(unsigned int i = 0; i<(int)rp->vies && fin == 0; i++) {

	rp->monde._41 = 10.0f - i * 5;
	
	if(rp->tcr != 0.0f && i + 1 == (int)rp->vies)
		rotation_Y(&rp->monde, rp->tcr+=.2f);

	projection(&rp->monde, &(*D3DD));
	obj2device_dessin_mesh(mtm_coeur->nbr_de_mat, mtm_coeur, &(*D3DD), &mtm_coeur->obj_mesh);

	if(rp->tcr > alpha)
		rp->tcr = 0.0f;

	}
}

void affich_modulea(LPDIRECT3DDEVICE9 *D3DD, _module_ *rp, _mesh_ *mtm_modulea) {
	
	rp->monde._42 = -15.0f;
	rp->monde._43 = 0.0f;
	rp->monde._41 = 0.0f;

	D3DMATRIX buff_mde = rp->monde;

	rotation_Y(&rp->monde, -rp->rot_cam/4);

	projection(&rp->monde, &(*D3DD));

	rp->monde = buff_mde;

	obj2device_dessin_mesh(mtm_modulea->nbr_de_mat, mtm_modulea, &(*D3DD), &mtm_modulea->obj_mesh);
}

void affich_laby(LPDIRECT3DDEVICE9 *D3DD, _module_ *rp, _mesh_ *mtm_laby) {

	rp->monde._41=rp->coord_0.x*cos(rp->module_rot)+rp->coord_0.z*sin(rp->module_rot);
	rp->monde._43=-rp->coord_0.x*sin(rp->module_rot)+rp->coord_0.z*cos(rp->module_rot);

	rotation_Y(&rp->monde, rp->module_rot);
	
	projection(&rp->monde, &(*D3DD));

	obj2device_dessin_mesh(mtm_laby->nbr_de_mat, mtm_laby, &(*D3DD), &mtm_laby->obj_mesh);
}

void affich_moduleb(LPDIRECT3DDEVICE9 *D3DD, _module_ *rp, _module_ *rp2, _mesh_ *mtm_moduleb) {

	rp2->monde._42 = -15.0f;
	rp2->monde._43 = 0.0f;
	rp2->monde._41 = 0.0f;
	rp2->monde._11 = rp2->monde._33 = 1.0f;
	rp2->monde._13 = rp2->monde._31 = 0.0f;

	float vx = rp->coord_0.x - rp2->coord_0.x;
	float vz = rp->coord_0.z - rp2->coord_0.z;

	rp2->monde._41=vx*cos(rp->module_rot)+vz*sin(rp->module_rot);
	rp2->monde._43=-vx*sin(rp->module_rot)+vz*cos(rp->module_rot);

	rotation_Y(&rp2->monde, rp->module_rot-rp2->module_rot);
	
	projection(&rp2->monde, &(*D3DD));

	obj2device_dessin_mesh(mtm_moduleb->nbr_de_mat, mtm_moduleb, &(*D3DD), &mtm_moduleb->obj_mesh);
}

void affich_missileb(LPDIRECT3DDEVICE9 *D3DD, _module_ *rp, _module_ *rp2, _mesh_ *mtm_missile, Missile cell2) {
	
	while(cell2) {
	
		rp2->monde._42 = -15.0f;
		rp2->monde._43 = 0.0f;
		rp2->monde._41 = 0.0f;
		rp2->monde._11 = rp2->monde._33 = 1.0f; rp2->monde._13 = rp2->monde._31 = 0.0f;

		float vz = rp->coord_0.z - cell2->coord.z;
		float vx = rp->coord_0.x - cell2->coord.x;

		rp2->monde._41=vx*cos(rp->module_rot)+vz*sin(rp->module_rot);
		rp2->monde._43=-vx*sin(rp->module_rot)+vz*cos(rp->module_rot);

		rotation_Y(&rp2->monde, rp->module_rot - cell2->t_rot);

		projection(&rp2->monde, &(*D3DD));

		obj2device_dessin_mesh(mtm_missile->nbr_de_mat, mtm_missile, &(*D3DD), &mtm_missile->obj_mesh);

		cell2 = cell2->suivant;
	}
}

void billboard_init(LPDIRECT3DDEVICE9 *D3DD, LPDIRECT3DTEXTURE9 *pText, LPDIRECT3DVERTEXBUFFER9 *pVB) {

    (*D3DD)->SetRenderState( D3DRS_LIGHTING, FALSE );

    (*D3DD)->SetRenderState( D3DRS_ALPHABLENDENABLE,   TRUE );
	(*D3DD)->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_ONE);
    (*D3DD)->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_ONE);

    (*D3DD)->SetStreamSource( 0, *pVB, 0, sizeof(VERTICES) );
    (*D3DD)->SetFVF( D3DFVF_XYZ|D3DFVF_DIFFUSE|D3DFVF_TEX1 );
    (*D3DD)->SetTexture( 0, *pText);

}

void billboard_end(LPDIRECT3DDEVICE9 *D3DD) {
    (*D3DD)->SetRenderState( D3DRS_ALPHATESTENABLE,    FALSE );
    (*D3DD)->SetRenderState( D3DRS_ALPHABLENDENABLE,   FALSE );
    (*D3DD)->SetRenderState( D3DRS_LIGHTING, TRUE );
}

void affich_eclairs(LPDIRECT3DDEVICE9 *D3DD, _module_ *rp) {

	projection(&rp->monde, &(*D3DD));
    (*D3DD)->DrawPrimitive( D3DPT_TRIANGLESTRIP, 0, 2 );

}

void affich_eclairs_a(LPDIRECT3DDEVICE9 *D3DD, LPDIRECT3DVERTEXBUFFER9 *pVB, LPDIRECT3DTEXTURE9 *pText, _module_ *rp) {

	rp->monde._42 = -15.0f;
	rp->monde._11 = rp->monde._33 = 1.0f;
	rp->monde._13 = rp->monde._31 = 0.0f;

	float gx = rp->coord_0.x - rp->rl.x;
	float gz = rp->coord_0.z - rp->rl.y;

	rp->monde._41=gx*cos(rp->module_rot)+gz*sin(rp->module_rot);
	rp->monde._43=-gx*sin(rp->module_rot)+gz*cos(rp->module_rot);

	rotation_Y(&rp->monde, rp->module_rot - rp->rl.rot);

	billboard_init(D3DD, &(pText[rp->nbr_texture++]), &(pVB[1]));
	affich_eclairs(D3DD, rp);
	billboard_end(D3DD);

	if(rp->nbr_texture > 4)
		rp->nbr_texture = 1;

}

void affich_eclairs_b(LPDIRECT3DDEVICE9 *D3DD, LPDIRECT3DVERTEXBUFFER9 *pVB, LPDIRECT3DTEXTURE9 *pText, _module_ *rp, _module_ *rp2) {

	rp2->monde._42 = -15.0f;
	rp2->monde._11 = rp2->monde._33 = 1.0f;
	rp2->monde._13 = rp2->monde._31 = 0.0f;

	float vx = rp->coord_0.x - rp2->rl.x;
	float vz = rp->coord_0.z - rp2->rl.y;

	rp2->monde._41=vx*cos(rp->module_rot)+vz*sin(rp->module_rot);
	rp2->monde._43=-vx*sin(rp->module_rot)+vz*cos(rp->module_rot);

	rotation_Y(&rp2->monde, rp->module_rot-rp2->rl.rot);
		
	billboard_init(D3DD, &(pText[rp2->nbr_texture]), &(pVB[1]));
	affich_eclairs(D3DD, rp2);
	billboard_end(D3DD);

}

void affich_hallos(LPDIRECT3DDEVICE9 *D3DD, _module_ *rp) {

	rp->monde._42 = -18.0f;

	if(rp->rot_cam>0) {

		rp->monde._41 = _A_ * cos(_fi_+rp->rot_cam/4);
		rp->monde._43 = _A_ * sin(_fi_+rp->rot_cam/4) - rp->rot_cam/2;
		rp->monde._13 = rp->monde._31 = 0.0f;
		rp->monde._11 = rp->monde._22 = rp->monde._33 = rp->coef_vitesse_module * .1f;

		projection(&rp->monde, &(*D3DD));
		(*D3DD)->DrawPrimitive( D3DPT_TRIANGLESTRIP, 0, 2 );

		rp->monde._41 = -_A_ * cos(_fi_-rp->rot_cam/4);
		rp->monde._43 = _A_ * sin(_fi_-rp->rot_cam/4) - rp->rot_cam/1.5;
		rp->monde._13 = rp->monde._31 = 0.0f;
		rp->monde._11 = rp->monde._22 = rp->monde._33 = rp->coef_vitesse_module * .1f;

		projection(&rp->monde, &(*D3DD));
	    (*D3DD)->DrawPrimitive( D3DPT_TRIANGLESTRIP, 0, 2 );
	}
	else {

		rp->monde._41 = -_A_ * cos(_fi_-rp->rot_cam/4);
		rp->monde._43 = _A_ * sin(_fi_-rp->rot_cam/4) + rp->rot_cam/2;
		rp->monde._13 = rp->monde._31 = 0.0f;
		rp->monde._11 = rp->monde._22 = rp->monde._33 = rp->coef_vitesse_module * .1f;

		projection(&rp->monde, &(*D3DD));
	    (*D3DD)->DrawPrimitive( D3DPT_TRIANGLESTRIP, 0, 2 );
	
		rp->monde._41 = _A_ * cos(_fi_+rp->rot_cam/4);
		rp->monde._43 = _A_ * sin(_fi_+rp->rot_cam/4) + rp->rot_cam/1.5;
		rp->monde._13 = rp->monde._31 = 0.0f;
		rp->monde._11 = rp->monde._22 = rp->monde._33 = rp->coef_vitesse_module * .1f;

		projection(&rp->monde, &(*D3DD));
        (*D3DD)->DrawPrimitive( D3DPT_TRIANGLESTRIP, 0, 2 );
	
	}

	rp->monde._11 = rp->monde._22 = rp->monde._33 = 1.0f;
    
}

void rotation_module(clavier *etm, _module_ *rp) {

	if (etm->droite==1 && rp->coef_rotation_module>=0.0f) {
		rp->module_rot+=.02*rp->coef_rotation_module;
		rp->coef_rotation_module+=0.20f;
		rp->rot_cam+=0.1f;
		if(rp->rot_cam>_PI*4) rp->rot_cam=_PI*4;
	}
	
	if (etm->gauche==1 && rp->coef_rotation_module<=0.0f) {
		rp->module_rot+=.02*rp->coef_rotation_module;
		rp->coef_rotation_module-=0.20f;
		rp->rot_cam-=0.1f;
		if(rp->rot_cam<-_PI*4) rp->rot_cam=-_PI*4;
	}

	if (etm->gauche==1 && rp->coef_rotation_module>=0.0f) {
		rp->module_rot+=.02*rp->coef_rotation_module;
		rp->coef_rotation_module-=0.20f;
		rp->rot_cam-=0.1f;
		if(rp->rot_cam<0.0f) rp->rot_cam=0.0f;
	}

	if (etm->droite==2 && rp->coef_rotation_module>=0.0f) {
		rp->module_rot+=.02*rp->coef_rotation_module;
		rp->coef_rotation_module-=0.20f;
		rp->rot_cam-=0.1f;
		if(rp->rot_cam<0.0f) rp->rot_cam=0.0f;
	}

	if (etm->droite==1 && rp->coef_rotation_module<=0.0f) {
		rp->module_rot+=.02*rp->coef_rotation_module;
		rp->coef_rotation_module+=0.20f;
		rp->rot_cam+=0.1f;
		if(rp->rot_cam>0.0f) rp->rot_cam=0.0f;
	}

	if (etm->gauche==2 && rp->coef_rotation_module<=0.0f) {
		rp->module_rot+=.02*rp->coef_rotation_module;
		rp->coef_rotation_module+=0.20f;
		rp->rot_cam+=0.1f;
		if(rp->rot_cam>0.0f) rp->rot_cam=0.0f;
	}
}

void deplacement(_module_ *rp, float p_z, float p_x, float cv, float cc) {

	rp->coord_0.z += p_z;
	rp->coord_0.x += p_x;
	rp->coef_vitesse_module += cv;
	rp->coef_cam += cc;
}

void collision_mur(_module_ *rp, float debut_, float fin_, coord_2D *c, unsigned char k1, unsigned char k2, float p) {

	for(unsigned int i=debut_; i<fin_; i++) 
		if (-c->x + rp->rayon>pl[i][2] && -c->x - rp->rayon<pl[i][2]) {
			if(-c->y > pl[i][k1] && -c->y < pl[i][k2])
				{c->x += p; return;}

			if(-c->y + rp->rayon>pl[i][k1] && -c->y - rp->rayon<pl[i][k2]) {
				if ((-c->x - pl[i][2]) * (-c->x - pl[i][2]) + (-c->y - pl[i][k1]) * (-c->y - pl[i][k1]) < rp->rayon * rp->rayon)
					{c->x += p; return;}

				if ((-c->x - pl[i][2]) * (-c->x - pl[i][2]) + (-c->y - pl[i][k2]) * (-c->y - pl[i][k2]) < rp->rayon * rp->rayon)
					{c->x += p; return;}
			}
		}
	
	return;
}

void missile_init(_module_ *rp, clavier *etm) {

	if (rp->missile==NULL)
	{
		
		rp->missile = (Missile)malloc(sizeof(Miss));
		rp->missile->coord.x=rp->coord_0.x;
		rp->missile->coord.z=rp->coord_0.z;
		rp->missile->t_rot=rp->module_rot;
		rp->missile->precedent = rp->missile->suivant = NULL;
	}
	else {
		Missile cellule = rp->missile;
		Missile celtmp = cellule;
	
		while(cellule->suivant)
			cellule = cellule->suivant;

		if (cellule->suivant==NULL) {
			cellule->suivant = (Missile)malloc(sizeof(Miss));
			cellule->suivant->coord.x=rp->coord_0.x;
			cellule->suivant->coord.z=rp->coord_0.z;
			cellule->suivant->t_rot=rp->module_rot;
			cellule->suivant->precedent=celtmp;
			cellule->suivant->suivant=NULL;
			}
		celtmp = cellule->suivant;
	}
	
	etm->feu=2;

}

void affich_missile(LPDIRECT3DDEVICE9 *D3DD, _mesh_ *mtm_missile, _module_ *rp, Missile cell) {

	while(cell) {
	
		rp->monde._41=(rp->coord_0.x-cell->coord.x)*cos(rp->module_rot)+(rp->coord_0.z-cell->coord.z)*sin(rp->module_rot);
		rp->monde._43=-(rp->coord_0.x-cell->coord.x)*sin(rp->module_rot)+(rp->coord_0.z-cell->coord.z)*cos(rp->module_rot);

		rotation_Y(&rp->monde, rp->module_rot - cell->t_rot);
			
		projection(&rp->monde, &(*D3DD));

		obj2device_dessin_mesh(mtm_missile->nbr_de_mat, mtm_missile, &(*D3DD), &mtm_missile->obj_mesh);

		cell->coord.x+=sin(cell->t_rot)*4;
		cell->coord.z-=cos(cell->t_rot)*4;

		cell = cell->suivant;
	}

}

void collision_missile(_module_ *rp, _module_ *rp2, Missile cell0) {
	unsigned int i;
	while(cell0) {

		int lib = 0;

		if(rp2->rayon*rp2->rayon>(rp2->coord_0.z-cell0->coord.z)*(rp2->coord_0.z-cell0->coord.z) + (rp2->coord_0.x-cell0->coord.x)*(rp2->coord_0.x-cell0->coord.x)) {

			if(DSbuffer[2] && et_module.haut!=1) {
				DSbuffer[2]->SetCurrentPosition(0);	// Met le fichier wav au dbut
				DSbuffer[2]->Play(0,0,0);				// Joue le son
			}

			rp2->tcr = .2f;
				
			rp2->vies-=.10f;

			if (rp2->vies < 0.0f && fin ==0) 

			fin = 1;

			lib = 1; 
			test_cell(&rp->missile, &cell0);
				
		}

		if(cell0->coord.z * cell0->coord.z + cell0->coord.x * cell0->coord.x > RAYON_LABY)
		{
			lib = 1;
			test_cell(&rp->missile, &cell0);
		}

		for(i=0; i<7; i++) 
			if (-20 < cell0->coord.z+pl[i][2] && 20 > cell0->coord.z+pl[i][2])
				if(-cell0->coord.x>pl[i][0] && -cell0->coord.x<pl[i][1])
				{
					lib = 1;
					test_cell(&rp->missile, &cell0);
				}

		for(i=7; i<15; i++) 
			if (-20 < cell0->coord.x+pl[i][2] && 20 > cell0->coord.x+pl[i][2])
				if(-cell0->coord.z>pl[i][0] && -cell0->coord.z<pl[i][1]) {
					lib = 1;
					test_cell(&rp->missile, &cell0);
				}

		if(lib == 1 && cell0->suivant == NULL) {free(cell0); cell0 = NULL;}
		if (cell0) cell0 = cell0->suivant;
		if(lib == 1 && cell0) {free(cell0->precedent);cell0 = NULL;}
	}
}

unsigned int cumul(FILE *fichier)
{

	unsigned int val = 0;

	val += fgetc(fichier) << 24;
	val += fgetc(fichier) << 16;
	val += fgetc(fichier) << 8;
	val += fgetc(fichier);

	return val;
}

void lecture(_module_ *rp, _module_ *rp2)
{

	FILE *fichier;
	fichier = fopen("param.alx", "rb");

	char c[10];
	unsigned int val;

	val = cumul(fichier);
	long_fenetre = val;

	val = cumul(fichier);
	larg_fenetre = val;
	
	val = cumul(fichier);
	rp->vies = rp2->vies = val;	

	val = cumul(fichier);
	ambiance = val;
	ambiance += val << 8;
	ambiance += val << 16;
	
	fclose(fichier);


}

VOID Rendu(HWND hWnd, unsigned int param, LPDIRECT3DDEVICE9 *D3DD, LPDIRECT3DTEXTURE9 *pText, LPDIRECT3DVERTEXBUFFER9 *pVB, _module_ *rp, _module_ *rp2, _mesh_ *mtm_modulea, _mesh_ *mtm_laby, _mesh_ *mtm_missile, _mesh_ *mtm_moduleb, _mesh_ *mtm_coeur, clavier *etm)
{
	
	unsigned int i;
	D3DVECTOR vect_ = {0.0f, -707.0f, 707.0f};
	
	if (timer(25000, temps)) return;

	(*D3DD)->Clear( 0, NULL, param, D3DCOLOR_XRGB(0,0,255), 1.0f, 0 );

	// dbut de la scne
	(*D3DD)->BeginScene();

 	Init_lumiere(&(*D3DD), ambiance);
	lumiere(0, 2, 2, 2, 2, vect_, 1000.0f, &(*D3DD));
	allumer_lum(0, &(*D3DD));

	if(fin == 300 && rp2->vies < 0)
		fini(hWnd);

	if(rp->coef_cam && rp->coef_cam != 20.0f)
		eloignement(D3DD, rp);

	vue_settransf(rp, &(*D3DD));

	perspective(mat_proj, &(*D3DD));

	if (fin != 0 && fin < 300) fin++;
	
	affich_vies(D3DD, mtm_coeur, 12.57, rp);

	affich_modulea(D3DD, rp, mtm_modulea);
	
	if (rp->coef_rotation_module<-10.0f)
		rp->coef_rotation_module=-10.0f;

	if (rp->coef_rotation_module>10.0f)
		rp->coef_rotation_module=10.0f;

	rotation_module(etm, rp);

	if (rp->module_rot>_2PI)
		rp->module_rot = 0.0f;
	
	if (rp->module_rot<0)
		rp->module_rot = _2PI;

	if (rp->collision == 0 && rp->stopecl == 1)
	{ DSbuffer[5]->Stop(); rp->stopecl = 0; }

	if (rp->coef_vitesse_module<0.0f)
	{rp->coef_vitesse_module=0.0f; rp->collision = 0; }
	
	if (rp->coef_vitesse_module>10)
		{rp->coef_vitesse_module=10; rp->collision = 0;	}

	float p_z = .3*rp->coef_vitesse_module*cos(rp->module_rot);
	float p_x = .3*rp->coef_vitesse_module*sin(rp->module_rot);

	if (((-rp->coord_0.x)-(-rp2->coord_0.x))*((-rp->coord_0.x)-(-rp2->coord_0.x))+((-rp->coord_0.z)-(-rp2->coord_0.z))*((-rp->coord_0.z)-(-rp2->coord_0.z)) < (rp->rayon+rp2->rayon)*(rp->rayon+rp2->rayon))
		rp->collision = 1;

	if(rp->coord_0.z * rp->coord_0.z + rp->coord_0.x * rp->coord_0.x > RAYON_LABY) {
		rp->collision = 1; rp->rl.x = rp->coord_0.x; rp->rl.y = rp->coord_0.z; rp->rl.rot = rp->module_rot;
			
		DSbuffer[5]->SetCurrentPosition(0);	// Met le fichier wav au dbut
		DSbuffer[5]->Play(0,0,0);				// Joue le son
		rp->stopecl = 1;
	}

		if (rp->collision == 1)
	{
		if (etm->bas==1)
			deplacement(rp, -p_z, p_x, .2f, -.3f);

		if (etm->bas==2)
			deplacement(rp, -p_z, p_x, -.2f, .3f);

		if (etm->haut!=0)
			deplacement(rp, +p_z, -p_x, -.2f, 0.0f);

	}
	else
	{
		
		if (etm->haut==1) 
			deplacement(rp, -p_z, +p_x, .2f, -.3f);
		
		if (etm->bas==1)
			deplacement(rp, p_z, -p_x, .2f, 0.0f);

		if (etm->haut==2)
			deplacement(rp, -p_z, p_x, -.2f, +.3f);
		
		if (etm->bas==2)
			deplacement(rp, +p_z, -p_x, -.2f, 0.0f);
	
	}

		if(rp->coef_cam>0)
			rp->coef_cam=0;

		if(rp->coef_cam<-20)
			rp->coef_cam=-20;

	if (rp->collision == 1)
		{ p_x*=-1; p_z*=-1; }

	coord_2D *coo = new coord_2D;

	if ((rp->collision == 1) || ((rp->module_rot>=0 && rp->module_rot<1.5708) || (rp->module_rot>=4.7124 && rp->module_rot<6.2632))) {
	
		coo->x = rp->coord_0.z;
		coo->y = rp->coord_0.x;
		
		collision_mur(rp, 0, 7, coo, 0, 1, p_z);
		
		rp->coord_0.z = coo->x;
		rp->coord_0.x = coo->y;
	}

	if ((rp->collision == 1) || (rp->module_rot>=0 && rp->module_rot<_PI)) {
	
		coo->x = rp->coord_0.x;
		coo->y = rp->coord_0.z;
		
		collision_mur(rp, 7, 15, coo, 0, 1, -p_x);
		
		rp->coord_0.z = coo->y;
		rp->coord_0.x = coo->x;
	}

	if ((rp->collision == 1) || (rp->module_rot>=_1_2EMI_PI && rp->module_rot<_3_2EMI_PI)) {
	
		coo->x = rp->coord_0.z;
		coo->y = rp->coord_0.x;
		
		collision_mur(rp, 15, 23, coo, 1, 0, p_z);
		
		rp->coord_0.z = coo->x;
		rp->coord_0.x = coo->y;
	}

	if ((rp->collision == 1) || (rp->module_rot>=_PI && rp->module_rot<_2PI)) {
	
		coo->x = rp->coord_0.x;
		coo->y = rp->coord_0.z;
		
		collision_mur(rp, 23, 30, coo, 1, 0, -p_x);
		
		rp->coord_0.z = coo->y;
		rp->coord_0.x = coo->x;
	}

	if (etm->feu==1 && fin < 50)
		missile_init(rp, etm);

	Missile cell = rp->missile;

	if (etm->feu==2)
		affich_missile(D3DD, mtm_missile, rp, cell);

	int destr = 0;

	Missile cell0 = rp->missile;

	collision_missile(rp, rp2, cell0);
	
	affich_laby(D3DD, rp, mtm_laby);
	affich_moduleb(D3DD, rp, rp2, mtm_moduleb);

	Missile cell2 = rp2->missile;

	affich_missileb(D3DD, rp, rp2, mtm_missile, cell2);

	if(rp->collision==1 && rp->stopecl == 1)
		affich_eclairs_a(D3DD, pVB, pText, rp);

	if(rp2->collision==1 && rp2->stopecl == 1)
		affich_eclairs_b(D3DD, pVB, pText, rp, rp2);
	
	billboard_init(D3DD, &(pText[0]), pVB);

	affich_hallos(D3DD, rp);

	billboard_end(D3DD);

	// fin de la scne
	(*D3DD)->EndScene();

	// affiche le back buffer  l'cran
	(*D3DD)->Present(NULL, NULL, NULL, NULL);

}

LRESULT CALLBACK MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{

    switch( msg )
    {

		case WM_DESTROY:
            Cleanup();
            PostQuitMessage(0);
            return 0;

	case WM_CREATE:

	break;

		case WM_KEYDOWN :

			switch(wParam) {
		
				case 'M':
					if(DSbuffer[0] && et_module.feu!=1) {
						DSbuffer[0]->SetCurrentPosition(0);	// Met le fichier wav au dbut
						DSbuffer[0]->Play(0,0,0);				// Joue le son
					}

					et_module.feu=1;

				break;

				case 'F':
					if(DSbuffer[0] && et_module2.feu!=1) {
						DSbuffer[0]->SetCurrentPosition(0);	// Met le fichier wav au dbut
						DSbuffer[0]->Play(0,0,0);				// Joue le son
					}
					
					et_module2.feu=1;
				break;

				case VK_UP:
					if(DSbuffer[3]&& et_module.haut!=1) {
						DSbuffer[3]->SetCurrentPosition(0);	// Met le fichier wav au dbut
						DSbuffer[3]->Play(0,0,0);				// Joue le son
					}
					if(DSbuffer[4]&& et_module.haut!=1) 
						DSbuffer[4]->Stop();
					
					et_module.haut=1;et_module.bas=0;


				break;

				case 'Z':
					if(DSbuffer[3]&& et_module2.haut!=1) {
						DSbuffer[3]->SetCurrentPosition(0);	// Met le fichier wav au dbut
						DSbuffer[3]->Play(0,0,0);				// Joue le son
					}
					if(DSbuffer[4]&& et_module2.haut!=1)
						DSbuffer[4]->Stop();
	
					et_module2.haut=1;et_module2.bas=0;
				break;

				case VK_RIGHT:
					et_module.droite=1;et_module.gauche=0;
				break;

				case 'D':
					et_module2.droite=1;et_module2.gauche=0;
				break;

				case VK_LEFT:
					et_module.gauche=1;et_module.droite=0;
				break;

				case 'Q':
					et_module2.gauche=1;et_module2.droite=0;
				break;

			}

			break;

		case WM_KEYUP :

			switch(wParam) {
		
				case VK_UP:
					if(DSbuffer[4]&& et_module.haut!=2) {
						DSbuffer[4]->SetCurrentPosition(0);	// Met le fichier wav au dbut
						DSbuffer[4]->Play(0,0,0);				// Joue le son
					}
					if(DSbuffer[3]&& et_module.haut!=2)
						DSbuffer[3]->Stop();
									
					et_module.haut=2;et_module.bas=0;
				break;

				case 'Z':
					if(DSbuffer[4]&& et_module2.haut!=2) {
						DSbuffer[4]->SetCurrentPosition(0);	// Met le fichier wav au dbut
						DSbuffer[4]->Play(0,0,0);				// Joue le son
					}
					if(DSbuffer[3]&& et_module2.haut!=2)
						DSbuffer[3]->Stop();
				
					et_module2.haut=2;et_module2.bas=0;
				break;

				case VK_RIGHT:
				et_module.droite=2;et_module.gauche=0;
				break;

				case 'D':
				et_module2.droite=2;et_module2.gauche=0;
				break;

				case VK_LEFT:
				et_module.gauche=2;et_module.droite=0;
				break;

				case 'Q':
				et_module2.gauche=2;et_module2.droite=0;
				break;

				case VK_ESCAPE:
				DestroyWindow(hWnd);
				break;

			}
		break;
	}
    return DefWindowProc( hWnd, msg, wParam, lParam );
}

INT WINAPI WinMain( HINSTANCE hInst, HINSTANCE, LPSTR, INT )
{

	_module_ *module1 = new _module_;
	_module_ *module2 = new _module_;

	module1->position_cam.x = 0.0f;
	module1->position_cam.y = 0.0f;
	module1->position_cam.z = -70.0f;
	module1->monde = identite();
	module1->rot_cam = 0.0f;
	module1->coef_rotation_module = 0.0f;
	module1->coef_vitesse_module = 0.0f;
	module1->coef_cam = 0.0f;
	module1->module_rot = 0.0f;
	module1->coord_0.x = 0.0f;
	module1->coord_0.y = 0.0f;
	module1->coord_0.z = 50.0f;
	module1->rayon = 20;
	module1->collision = 0;
	module1->missile = NULL;
	module1->tcr = 0.0f;
	module1->nbr_texture = 1;
	module1->stopecl = 0;

	module2->position_cam.x = 0.0f;
	module2->position_cam.y = 0.0f;
	module2->position_cam.z = -70.0f;
	module2->monde = identite();
	module2->rot_cam = 0.0f;
	module2->coef_rotation_module = 0.0f;
	module2->coef_vitesse_module = 0.0f;
	module2->coef_cam = 0.0f;
	module2->module_rot = 0.0f;
	module2->coord_0.x = 0.0f;
	module2->coord_0.y = 0.0f;
	module2->coord_0.z = -50.0f;
	module2->rayon = 20;
	module2->collision = 0;
	module2->missile = NULL;
	module2->tcr = 0.0f;
	module2->nbr_texture = 1;
	module2->stopecl = 0;

	lecture(module1, module2);

    // Enregistre la classe de la fentre
    WNDCLASSEX wc = {
		sizeof(WNDCLASSEX),
		CS_CLASSDC, MsgProc,
		0L, 0L,
		GetModuleHandle(NULL),
		NULL, NULL, NULL, NULL,
		"SuperBattle", NULL };

		RegisterClassEx( &wc );

		// Cration de la fentre d'application
		HWND hWnd = CreateWindow(
		"Superbattle", "Superbattle",
		WS_OVERLAPPEDWINDOW,
		100, 100, long_fenetre, larg_fenetre * 2,
		GetDesktopWindow(),
		NULL, wc.hInstance, NULL );

		//Cration des fentres filles
		HWND hCtrl_1 = CreateWindow("EDIT", "", WS_CHILD|WS_VISIBLE, 0, 0, long_fenetre, larg_fenetre, hWnd, NULL, hInst, NULL);

		HWND hCtrl_2 = CreateWindow("EDIT", "", WS_CHILD|WS_VISIBLE, 0, larg_fenetre + 1, long_fenetre, larg_fenetre, hWnd, NULL, hInst, NULL);

		if(( SUCCEEDED( InitD3D(hCtrl_1, long_fenetre, larg_fenetre, &obj_Direct3D, &obj_Direct3DDevice))
		&&
		SUCCEEDED( InitD3D(hCtrl_2, long_fenetre, larg_fenetre, &obj_Direct3D2, &obj_Direct3DDevice2))
		) == E_FAIL)
			return -1;

		unsigned int i, k = 0;

		char chemin_wav[NBR_SNDS][11] = {"missi.wav", "musik.wav", "impact.wav", "accel.wav", "decel.wav", "elec.wav"};
		char chemin_tex[NBR_TEXT][13] = {"glow.bmp", "eclairs1.bmp", "eclairs2.bmp", "eclairs3.bmp", "eclairs4.bmp"};

		if(init_DS(hWnd, &obj_DirectSound) != DS_OK)
			return -1;
		
		for(i = 0; i < NBR_SNDS; i++)
			if(LoadDirectSound(&obj_DirectSound, &(DSbuffer[i]), chemin_wav[i]) != S_OK)
				return -1;

		for(i = 0; i < NBR_TEXT; i++) {

			if(charge_textures(&obj_Direct3DDevice, &(obj_texture[i]), chemin_tex[i]) != S_OK)
				return -1;
			if(charge_textures(&obj_Direct3DDevice2, &(obj_texture2[i]), chemin_tex[i]) != S_OK)
				return -1;
		}

		if(init_vertices(&obj_Direct3DDevice, &(obj_DirectVB[0]), 20, 20) != S_OK)
			return -1;
		if(init_vertices(&obj_Direct3DDevice2, &(obj_DirectVB2[0]), 20, 20) != S_OK)
			return -1;
		if(init_vertices(&obj_Direct3DDevice, &(obj_DirectVB[1]), 100, 100) != S_OK)
			return -1;
		if(init_vertices(&obj_Direct3DDevice2, &(obj_DirectVB2[1]), 100, 100) != S_OK)
			return -1;

  // vrifie prsence de l'horloge de prcision et initialise temps
		if (!(temps = horloge())) return -1;

		mat_proj = matr_persp(_PI/4, 50.0f, 300.0f, larg_fenetre, long_fenetre);

		D3DVECTOR b = {0.0f, -.707f, .707f};

		vue(module1, b, &obj_Direct3DDevice);
		vue(module2, b, &obj_Direct3DDevice2);

		_A_ = sqrt(7.3*7.3 + 16.8*16.8);	
		_fi_ = asin(-16.8/_A_);

		// cration des diffrents mesh

		char chemin[5][10] = {"module.x", "module2.x", "laby.x", "missile.x", "coeur.x"};

		for(i = 0; i<10; i+=2) {
			mtm[i] = charge_mesh(chemin[k], &obj_Direct3DDevice);
			if(mtm[i]==NULL)
				return -1;

			mtm[i+1] = charge_mesh(chemin[k], &obj_Direct3DDevice2);
			if(mtm[i+1]==NULL)
				return -1;
			k++;
		}

		ShowWindow(hWnd, SW_SHOWDEFAULT);
		UpdateWindow(hWnd);

	if(DSbuffer[1]) {
	DSbuffer[1]->SetCurrentPosition(0);	// Met le fichier wav au dbut
	DSbuffer[1]->Play(0,0,DSBPLAY_LOOPING);				// Joue le son
				}

		MSG msg;
		ZeroMemory( &msg, sizeof(msg) );

		while( msg.message!=WM_QUIT )
		{
			if( PeekMessage( &msg, NULL, 0U, 0U, PM_REMOVE ) )
			{
				TranslateMessage( &msg );
				DispatchMessage( &msg );
			}
			else {
				Rendu(hCtrl_2, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER, &obj_Direct3DDevice, obj_texture, obj_DirectVB, module1, module2, mtm[0], mtm[4], mtm[6], mtm[2], mtm[8], &et_module);
				Rendu(hCtrl_1, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER, &obj_Direct3DDevice2, obj_texture2, obj_DirectVB2, module2, module1, mtm[3], mtm[5], mtm[7], mtm[1], mtm[9], &et_module2);
			}
		}
   
		UnregisterClass("Superbattle", wc.hInstance);
	return 0;

  }

