#include <d3d9.h>

#define _PI 3.141592654
#define _2PI 6.283185307
#define _1_2EMI_PI 1.570796327
#define _3_2EMI_PI 4.71238898

#define RAYON_LABY 100000
#define NBR_TEXT 5

static unsigned int long_fenetre, larg_fenetre;
static unsigned int ambiance;

typedef struct _missile_ *Missile;

typedef struct _missile_ {
	D3DVECTOR coord;
	float t_rot;
	Missile suivant, precedent;
} Miss;

struct coord_2D {
	float x, y, rot;
};

typedef struct {
	D3DMATRIX view_matr;
	D3DVECTOR position_cam; 
	D3DMATRIX monde;
	float rot_cam, coef_rotation_module, coef_vitesse_module, coef_cam, module_rot;
	D3DVECTOR coord_0;
	Missile missile;
	float rayon, tcr;
	unsigned char collision, stopecl;
	float vies;

	//collision avec l extrmit du labyrinthe
	coord_2D rl;
	unsigned int nbr_texture;

} _module_;

struct clavier {
	unsigned char gauche;
	unsigned char droite;
	unsigned char haut;
	unsigned char bas;
	unsigned char feu;
};

